#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xalien.h"

#include "bitmap/alien0.xbm"
#include "bitmap/alien1.xbm"
#include "bitmap/alien2.xbm"
#include "bitmap/alien3.xbm"
#include "bitmap/ana1.xbm"
#include "bitmap/ana2.xbm"
#include "bitmap/ana3.xbm"
#include "bitmap/ana4.xbm"
#include "bitmap/ana5.xbm"
#include "bitmap/keva0.xbm"
#include "bitmap/keva1.xbm"
#include "bitmap/keva2.xbm"
#include "bitmap/keva3.xbm"
#include "bitmap/kevb0.xbm"
#include "bitmap/kevb1.xbm"
#include "bitmap/kevb2.xbm"
#include "bitmap/kevb3.xbm"
#include "bitmap/kevc0.xbm"
#include "bitmap/kevc1.xbm"
#include "bitmap/kevc2.xbm"
#include "bitmap/kevc3.xbm"
#include "bitmap/paku0.xbm"
#include "bitmap/paku1.xbm"
#include "bitmap/paku2.xbm"
#include "bitmap/paku3.xbm"
#include "bitmap/ume1.xbm"
#include "bitmap/ume2.xbm"
#include "bitmap/ume3.xbm"
#include "bitmap/ume4.xbm"
#include "bitmap/zubo0.xbm"
#include "bitmap/zubo1.xbm"

extern char map[];

extern Display *d;
extern Window  w;
extern GC      gc[COLORS];

Pixmap	pix[PICS];

void pix_init()
{
  pix[ALIEN0]=XCreateBitmapFromData(d,w,alien0_bits,alien0_width,alien0_height);
  pix[ALIEN1]=XCreateBitmapFromData(d,w,alien1_bits,alien1_width,alien1_height);
  pix[ALIEN2]=XCreateBitmapFromData(d,w,alien2_bits,alien2_width,alien2_height);
  pix[ALIEN3]=XCreateBitmapFromData(d,w,alien3_bits,alien3_width,alien3_height);

  /* kebiishi picture 1 */
  pix[KEVA0]=XCreateBitmapFromData(d,w,keva0_bits,keva0_width,keva0_height);
  pix[KEVA1]=XCreateBitmapFromData(d,w,keva1_bits,keva1_width,keva1_height);
  pix[KEVA2]=XCreateBitmapFromData(d,w,keva2_bits,keva2_width,keva2_height);
  pix[KEVA3]=XCreateBitmapFromData(d,w,keva3_bits,keva3_width,keva3_height);

  /* kebiishi picture 2 */
  pix[KEVB0]=XCreateBitmapFromData(d,w,kevb0_bits,kevb0_width,kevb0_height);
  pix[KEVB1]=XCreateBitmapFromData(d,w,kevb1_bits,kevb1_width,kevb1_height);
  pix[KEVB2]=XCreateBitmapFromData(d,w,kevb2_bits,kevb2_width,kevb2_height);
  pix[KEVB3]=XCreateBitmapFromData(d,w,kevb3_bits,kevb3_width,kevb3_height);

  /* kebiishi picture anahori */
  pix[KEVC0]=XCreateBitmapFromData(d,w,kevc0_bits,kevc0_width,kevc0_height);
  pix[KEVC1]=XCreateBitmapFromData(d,w,kevc1_bits,kevc1_width,kevc1_height);
  pix[KEVC2]=XCreateBitmapFromData(d,w,kevc2_bits,kevc2_width,kevc2_height);
  pix[KEVC3]=XCreateBitmapFromData(d,w,kevc3_bits,kevc3_width,kevc3_height);

  /* kebiishi eated picture */
  pix[PAKU0]=XCreateBitmapFromData(d,w,paku0_bits,paku0_width,paku0_height);
  pix[PAKU1]=XCreateBitmapFromData(d,w,paku1_bits,paku1_width,paku1_height);
  pix[PAKU2]=XCreateBitmapFromData(d,w,paku2_bits,paku2_width,paku2_height);
  pix[PAKU3]=XCreateBitmapFromData(d,w,paku3_bits,paku3_width,paku3_height);

  /* hole picture */
  pix[ANA1]=XCreateBitmapFromData(d,w,ana1_bits,ana1_width,ana1_height);
  pix[ANA2]=XCreateBitmapFromData(d,w,ana2_bits,ana2_width,ana2_height);
  pix[ANA3]=XCreateBitmapFromData(d,w,ana3_bits,ana3_width,ana3_height);
  pix[ANA4]=XCreateBitmapFromData(d,w,ana4_bits,ana4_width,ana4_height);
  pix[ANA5]=XCreateBitmapFromData(d,w,ana5_bits,ana5_width,ana5_height);

  pix[UME1]=XCreateBitmapFromData(d,w,ume1_bits,ume1_width,ume1_height);
  pix[UME2]=XCreateBitmapFromData(d,w,ume2_bits,ume2_width,ume2_height);
  pix[UME3]=XCreateBitmapFromData(d,w,ume3_bits,ume3_width,ume3_height);
  pix[UME4]=XCreateBitmapFromData(d,w,ume4_bits,ume4_width,ume4_height);

  pix[ZUBO0]=XCreateBitmapFromData(d,w,zubo0_bits,zubo0_width,zubo0_height);
  pix[ZUBO1]=XCreateBitmapFromData(d,w,zubo1_bits,zubo1_width,zubo1_height);
}

/* LN^𓾂 */
int GET_CHAR(x,y)
int x,y;
{
    return map[BASE+x+y*46];
}

/* LN^ */
void CLEAR_CHAR(x,y)
int x,y;
{
    XFillRectangle(d,w,gc[BLUE] ,X2X(x), Y2Y(y), CSIZ, CSIZ);
    map[BASE+x+y*46]    = SPACE;
    map[BASE+x+y*46+1]  = SPACE;
    map[BASE+x+y*46+46] = SPACE;
    map[BASE+x+y*46+47] = SPACE;
}

/* 
 *  ALIENx,yɕ\ 
 *
 *     Ń}N悤
 *     code : LN^R[h
 *     vec  : 0: 1: 2: 3:E
 */
void PUT_CHAR(x,y,code,color)
int x,y,code,color;
{
    XCopyPlane(d,pix[code],w,gc[color],0,0,CSIZ,CSIZ,X2X(x),Y2Y(y),1);
    map[BASE+x+y*46]    = code;
    map[BASE+x+y*46+1]  = code;
    map[BASE+x+y*46+46] = code;
    map[BASE+x+y*46+47] = code;
}

void PUT_ALIEN(x,y,vec)
int x,y,vec;
{
    PUT_CHAR(x, y, ALIEN0+vec, RED);
}

void PUT_KEV(x,y,vec)
int x,y,vec;
{
    if ((y & 1) || (x & 1)) {
        PUT_CHAR(x, y, KEVB0+vec, YELLOW);	/* pattern 2 */
    } else {
        PUT_CHAR(x, y, KEVA0+vec, YELLOW);	/* pattern 1 */
    }
}

void PUT_PAKU(x,y,vec)
int x,y,vec;
{
    switch (vec) {
        case UP:
            y -= 2;
            break;
        case DOWN:
            break;
        case LEFT:
            x -= 2;
            break;
        case RIGHT:
            break;
    }
    XCopyPlane(d,pix[PAKU0+vec],w,gc[YELLOW],0,0,
    		(vec < 2) ? CSIZ   : CSIZ*2,
    		(vec < 2) ? CSIZ*2 : CSIZ  ,
    		X2X(x),Y2Y(y),1);
    XFlush(d);
}
